diff --git a/htl/Makefile b/htl/Makefile
index 72e37fbd..a7b013ec 100644
--- a/htl/Makefile
+++ b/htl/Makefile
@@ -46,7 +46,6 @@ libpthread-routines := pt-attr pt-attr-destroy pt-attr-getdetachstate	    \
 	pt-alloc							    \
 	pt-create							    \
 	pt-getattr							    \
-	pt-equal							    \
 	pt-dealloc							    \
 	pt-detach							    \
 	pt-exit								    \
@@ -165,7 +164,7 @@ headers :=				\
 distribute :=
 
 routines := forward libc_pthread_init alloca_cutoff htlfreeres pt-total \
-	    pt-dep-self
+	    pt-dep-self pt-equal
 shared-only-routines = forward
 
 extra-libs := libpthread
diff --git a/htl/Versions b/htl/Versions
index 9ec84811..1ef8a6d0 100644
--- a/htl/Versions
+++ b/htl/Versions
@@ -83,7 +83,7 @@ libpthread {
     pthread_condattr_getpshared; pthread_condattr_init;
     pthread_condattr_setclock; pthread_condattr_setpshared;
 
-    pthread_create; pthread_detach; pthread_equal; pthread_exit;
+    pthread_create; pthread_detach; pthread_exit;
 
     pthread_getattr_np;
 
diff --git a/htl/forward.c b/htl/forward.c
index 00527348..d0f775a2 100644
--- a/htl/forward.c
+++ b/htl/forward.c
@@ -102,10 +102,6 @@ FORWARD (pthread_cond_timedwait,
 	 (pthread_cond_t *cond, pthread_mutex_t *mutex,
 	  const struct timespec *abstime), (cond, mutex, abstime), 0)
 
-FORWARD (pthread_equal, (pthread_t thread1, pthread_t thread2),
-	 (thread1, thread2), 1)
-
-
 /* Use an alias to avoid warning, as pthread_exit is declared noreturn.  */
 FORWARD_NORETURN (__pthread_exit, void, (void *retval), (retval),
 		  exit (EXIT_SUCCESS))
diff --git a/htl/pt-initialize.c b/htl/pt-initialize.c
index 02e6ad6b..1d948c40 100644
--- a/htl/pt-initialize.c
+++ b/htl/pt-initialize.c
@@ -47,7 +47,6 @@ static const struct pthread_functions pthread_functions = {
   .ptr_pthread_cond_signal = __pthread_cond_signal,
   .ptr_pthread_cond_wait = __pthread_cond_wait,
   .ptr_pthread_cond_timedwait = __pthread_cond_timedwait,
-  .ptr_pthread_equal = __pthread_equal,
   .ptr___pthread_exit = __pthread_exit,
   .ptr_pthread_getschedparam = __pthread_getschedparam,
   .ptr_pthread_setschedparam = __pthread_setschedparam,
diff --git a/sysdeps/htl/pthread-functions.h b/sysdeps/htl/pthread-functions.h
index ccccc8e5..095a61e6 100644
--- a/sysdeps/htl/pthread-functions.h
+++ b/sysdeps/htl/pthread-functions.h
@@ -45,7 +45,6 @@ int __pthread_cond_signal (pthread_cond_t *);
 int __pthread_cond_wait (pthread_cond_t *, pthread_mutex_t *);
 int __pthread_cond_timedwait (pthread_cond_t *, pthread_mutex_t *,
 			     const struct timespec *);
-int __pthread_equal (pthread_t, pthread_t);
 void __pthread_exit (void *) __attribute__ ((__noreturn__));
 int __pthread_getschedparam (pthread_t, int *, struct sched_param *);
 int __pthread_setschedparam (pthread_t, int,
@@ -101,7 +100,6 @@ struct pthread_functions
   int (*ptr_pthread_cond_wait) (pthread_cond_t *, pthread_mutex_t *);
   int (*ptr_pthread_cond_timedwait) (pthread_cond_t *, pthread_mutex_t *,
 				     const struct timespec *);
-  int (*ptr_pthread_equal) (pthread_t, pthread_t);
   void (*ptr___pthread_exit) (void *) __attribute__ ((__noreturn__));
   int (*ptr_pthread_getschedparam) (pthread_t, int *, struct sched_param *);
   int (*ptr_pthread_setschedparam) (pthread_t, int,
diff --git a/sysdeps/mach/hurd/i386/libc.abilist b/sysdeps/mach/hurd/i386/libc.abilist
index 4e3200ef..26552958 100644
--- a/sysdeps/mach/hurd/i386/libc.abilist
+++ b/sysdeps/mach/hurd/i386/libc.abilist
@@ -28,6 +28,7 @@ GLIBC_2.11 mkostemps F
 GLIBC_2.11 mkostemps64 F
 GLIBC_2.11 mkstemps F
 GLIBC_2.11 mkstemps64 F
+GLIBC_2.12 pthread_equal F
 GLIBC_2.13 __fentry__ F
 GLIBC_2.14 syncfs F
 GLIBC_2.15 __fdelt_chk F
diff --git a/sysdeps/mach/hurd/i386/libpthread.abilist b/sysdeps/mach/hurd/i386/libpthread.abilist
index b9c9b75c..84f2643b 100644
--- a/sysdeps/mach/hurd/i386/libpthread.abilist
+++ b/sysdeps/mach/hurd/i386/libpthread.abilist
@@ -65,7 +65,6 @@ GLIBC_2.12 pthread_condattr_setclock F
 GLIBC_2.12 pthread_condattr_setpshared F
 GLIBC_2.12 pthread_create F
 GLIBC_2.12 pthread_detach F
-GLIBC_2.12 pthread_equal F
 GLIBC_2.12 pthread_exit F
 GLIBC_2.12 pthread_getattr_np F
 GLIBC_2.12 pthread_getconcurrency F